blob: fcef0f59d5539c61499e70d2566ccc0c492da90a [file] [log] [blame]
Sam Ravnborgae215b12006-01-08 18:39:44 +01001#!/bin/sh
2# Check ncurses compatibility
3
4# What library to link
5ldflags()
6{
Mike Frysinger03c95872007-05-17 15:06:31 -04007 for ext in so a dylib ; do
8 for lib in ncursesw ncurses curses ; do
9 $cc -print-file-name=lib${lib}.${ext} | grep -q /
10 if [ $? -eq 0 ]; then
11 echo "-l${lib}"
12 exit
13 fi
14 done
15 done
Sam Ravnborg60f33b82006-01-15 15:28:35 +010016 exit 1
Sam Ravnborgae215b12006-01-08 18:39:44 +010017}
18
19# Where is ncurses.h?
20ccflags()
21{
22 if [ -f /usr/include/ncurses/ncurses.h ]; then
23 echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses.h>"'
24 elif [ -f /usr/include/ncurses/curses.h ]; then
25 echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses/curses.h>"'
26 elif [ -f /usr/include/ncurses.h ]; then
27 echo '-DCURSES_LOC="<ncurses.h>"'
28 else
29 echo '-DCURSES_LOC="<curses.h>"'
30 fi
31}
32
Sam Ravnborg3835f822006-01-21 12:03:09 +010033# Temp file, try to clean up after us
34tmp=.lxdialog.tmp
35trap "rm -f $tmp" 0 1 2 3 15
36
Sam Ravnborgae215b12006-01-08 18:39:44 +010037# Check if we can link to ncurses
38check() {
Sam Ravnborgb44158d2008-05-01 19:29:47 +020039 $cc -xc - -o $tmp 2>/dev/null <<'EOF'
40#include CURSES_LOC
41main() {}
42EOF
Sam Ravnborgae215b12006-01-08 18:39:44 +010043 if [ $? != 0 ]; then
Sam Ravnborg6e588f62007-12-09 20:11:15 +010044 echo " *** Unable to find the ncurses libraries or the" 1>&2
45 echo " *** required header files." 1>&2
46 echo " *** 'make menuconfig' requires the ncurses libraries." 1>&2
47 echo " *** " 1>&2
48 echo " *** Install ncurses (ncurses-devel) and try again." 1>&2
49 echo " *** " 1>&2
50 exit 1
Sam Ravnborgae215b12006-01-08 18:39:44 +010051 fi
52}
53
54usage() {
Sam Ravnborgf6682f92008-12-03 22:11:14 +010055 printf "Usage: $0 [-check compiler options|-ccflags|-ldflags compiler options]\n"
Sam Ravnborgae215b12006-01-08 18:39:44 +010056}
57
Mike Frysingere99c3432007-05-23 21:37:45 -040058if [ $# -eq 0 ]; then
Sam Ravnborgae215b12006-01-08 18:39:44 +010059 usage
60 exit 1
61fi
62
Sam Ravnborg3835f822006-01-21 12:03:09 +010063cc=""
Sam Ravnborgae215b12006-01-08 18:39:44 +010064case "$1" in
65 "-check")
66 shift
Sam Ravnborg60f33b82006-01-15 15:28:35 +010067 cc="$@"
Sam Ravnborgae215b12006-01-08 18:39:44 +010068 check
69 ;;
70 "-ccflags")
71 ccflags
72 ;;
73 "-ldflags")
Sam Ravnborg60f33b82006-01-15 15:28:35 +010074 shift
75 cc="$@"
Sam Ravnborgae215b12006-01-08 18:39:44 +010076 ldflags
77 ;;
78 "*")
79 usage
80 exit 1
81 ;;
82esac